
//+------------------------------------------------------------------+
//|                              Jim Sloman's natural moving average |
//|                                                          nma.mq4 |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Pink

//
//
//
//
//

extern int NMAPeriod = 20;
extern int Smooth    = 1;  

double buffer1[];
double buffer2[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer (0,buffer1);  SetIndexEmptyValue(0,0.00); SetIndexDrawBegin(0,NMAPeriod+1);
   SetIndexBuffer (1,buffer2);  SetIndexEmptyValue(1,0.00);
   IndicatorShortName ("NMA");
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int      counted_bars=IndicatorCounted();
   int      limit,i;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;

   //
   //
   //
   //
   //
               
   for(i = limit; i >= 0; i--)
   {
      double ratio = 0.00;
      double sumd  = 0.00;
      double suma  = 0.00;
      for (int k=0; k<NMAPeriod; k++)
      {
         double diff  = MathAbs(MathLog(Close[i+k])*100000-MathLog(Close[i+k+1])*100000);
                sumd += diff;
                suma += diff*(MathSqrt(k+1)-MathSqrt(k)); 
      }            
      if (sumd != 0) ratio = MathRound(suma) / MathRound(sumd);

      //
      //
      //
      //
      //
      
      buffer2[i] = buffer2[i+1] + (ratio * (Close[i]-buffer2[i+1])); 
      buffer1[i] = smooth(buffer2,i);
   }
   return(0);
}



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double smooth(double& array[],int i)
{
   double result;
      if (Smooth <= 0) result = (array[i]);
      if (Smooth == 1) result = (array[i] +   array[i+1] +   array[i+2])/3 ;
      if (Smooth == 2) result = (array[i] + 2*array[i+1] + 2*array[i+2] +   array[i+3])/6 ;
      if (Smooth >= 3) result = (array[i] + 2*array[i+1] + 3*array[i+2] + 3*array[i+3] + 2*array[i+4] + array[i+5])/12 ;
   return(result);
}   

